<?php
/*
Plugin Name: Whale-Kit
Plugin URI: http://ili.com.ua/whale-kit
Description: Kit of advanced widgets
Author: Yuriy Stepanov (stur)
Version: 1.0.0
Author URI: http://ili.com.ua/
*/

define("WHALE_KIT_ENABLE", 1);

load_plugin_textdomain('whalekit', PLUGINDIR.'/'.dirname(plugin_basename(__FILE__)).'/lang/');

add_action('wp_print_styles', 'wk_inclode_css');
function  wk_inclode_css(){
    $wkStyleUrl = WP_PLUGIN_URL . '/whale-kit/wk-style.css';
    $wkStyleFile = WP_PLUGIN_DIR . '/whale-kit/wk-style.css';
    if ( file_exists($wkStyleFile) ) {
        wp_register_style('whale-kit', $wkStyleUrl);
        wp_enqueue_style( 'whale-kit');
    }
}




class Whale_Kit_Widget  extends WP_Widget{
    var $wk_options = 'wk_options';
    function wk_widget_input($name, $instance, $type = 'text'){
        $curen_val = $instance[$name];
        if($type == 'text'):
?>
        <label for="<?php echo $this->get_field_id($name); ?>"><?php _e($name); ?>:<br /><input  id="<?php echo $this->get_field_id($name); ?>" name="<?php echo $this->get_field_name($name); ?>" type="<?=$type?>" value="<?php echo $curen_val; ?>" /></label>
<?
        elseif($type == 'checkbox'):
        $checked = ($curen_val)?'checked="checked"':'';
?>
        <label for="<?php echo $this->get_field_id($name); ?>"><?php _e($name); ?>: <input id="<?php echo $this->get_field_id($name); ?>" name="<?php echo $this->get_field_name($name); ?>" type="<?=$type?>" <?=$checked?> /></label>
<?
        endif;
    }

    function wk_widget_select($arr, $name, $instance){
        $curen_val = $instance[$name];
    ?>
        <label for="<?php echo $this->get_field_id($name); ?>"><?php _e($name); ?>:
            <select id="<?php echo $this->get_field_id($name); ?>" name="<?php echo $this->get_field_name($name); ?>" size="1">
            <?foreach($arr as $val):
                if($val == $curen_val)  $selected =  'selected="selected"';
                else  $selected = '';
            ?>
                <option <?=$selected?> value="<?=$val?>"><?=$val?></option>
            <?endforeach?>
            </select>
        </label>
<?php
    }
    function get_all_childs($childs){
        foreach($childs as $page){
            $res[$page->key] = $page;
            if($page->childs){
                $res = array_merge($res,$this->get_all_childs($page->childs));
            }
        }
        return  $res;
    }




    function sub_text($st){
       //$st = preg_replace('~([\w\d]+)([\,\.\?\!\;\-]+)([\w\d]+)~u', '\1\2 \3',$st);
       $len = $this->instance['title_lenght'];
       if($this->utf8_strlen($st)<=$len) return trim($st);
       $st = strip_tags($st);
       $st = str_replace('<!--more-->','',$st);
       $arr = preg_split('~([\s\,\.\?\!\;\-]+)~u', $st,-1,PREG_SPLIT_DELIM_CAPTURE);
       $st = '';
       foreach ($arr as $key=>$value) {
          if($this->utf8_strlen($st.$value)<$len )
            $st .= $value;
          else
             return $this->instance['end_cut'] ? $st.$this->instance['end_cut']:$st;
       }
       return trim($st);
    }

    function utf8_strlen($s) {
        $c = strlen($s); $l = 0;
        for ($i = 0; $i < $c; ++$i) if ((ord($s[$i]) & 0xC0) != 0x80) ++$l;
        return $l;
    }

}


?>