<?
/*
Plugin Name: Whale-Kit Categories widget
Plugin URI: http://ili.com.ua/whale-kit/categories-widget
Description: Whale-Kit advanced categories widget
Author: Yuriy Stepanov (stur)
Version: 1.0.0
Author URI: http://ili.com.ua/
*/

if(class_exists('Whale_Kit_Widget')){
class WK_Categories  extends Whale_Kit_Widget{
    function WK_Categories(){
        parent::WP_Widget(false, $name = 'WK_Categories');
    }

/*  [0] => stdClass Object
        (
            [term_id] => 9
            [name] => one
            [slug] => one
            [term_group] => 0
            [term_taxonomy_id] => 9
            [taxonomy] => category
            [description] =>
            [parent] => 0
            [count] => 1
        )
*/
   function get_term_ancestors(&$term){
          if( $term->parent){
               $parent = get_term( $term->parent,  $term->taxonomy);
               return array_merge(array($term->parent),$this->get_term_ancestors($parent) );
          }
          else
            return array();
   }
   function get_terms_filter($terms, $taxonomies, $args){

        global $wp_query;
        if(!sizeof($terms)) return $terms;
        if( is_category() || is_tax() ){
           $current_id = $wp_query->get_queried_object_id();
        }

        foreach($terms as $key=>$value){
            $terms[$key]->key = $key;
            $ids[$value->term_id] = & $terms[$key];
        }

        foreach($ids as $id=>$term){
            if($term->parent){
               $ids[$term->parent]->childs[$id] = & $ids[$id];
            }else{
               $tree[$id] = & $ids[$id];
            }
        }
        if($current_id){
            $current_term = get_term( $current_id,  $args['taxonomy']);
            $ancestors = $this->get_term_ancestors($current_term);
            $ancestors = array_reverse($ancestors);

            foreach($ancestors as $key=>$term_id){
                 $ids[$term_id]->current_cat_ancestor = 1;
            }

            $ancestors[] =  $current_id;
            if($args['start_depth']){
                $start_id = $ancestors[$args['start_depth']-1];
                if(!$ids[$start_id]->childs) return '';
                $terms = $this->get_all_childs($ids[$start_id]->childs);
            }

            if($args['collapse'] and ($args['depth'] !== -1) ){
                foreach($terms as $key=>$term){
                    if($term->parent){
                            if(in_array($term->parent,$ancestors) )
                                $result[$key] = $term;
                    }
                    else
                        $result[$key] = $term;
                }
                return $result;
            }


        }else{

            if($args['start_depth']) return '';

            foreach($terms as $key=>$term){
                if(!$term->parent){
                    $result[$key] = $term;
                }
            }
            return $result;


        }
        return  $terms;
   }

    function widget($args, $instance) {
        extract( $args );
        $title = apply_filters('widget_title', $instance['title']);
        $instance['title_li'] = false;
        if($instance['start_depth'] OR $instance['collapse']){
            add_filter('get_terms', array(&$this, 'get_terms_filter'), 10, 3);
            $instance['walker'] = new WK_Walker_Category;
        }
        $instance['echo'] = 0;
        $html = wp_list_categories($instance);
        if($html):
        ?>
              <?php echo $before_widget; ?>
                  <?php if ( $title )
                        echo $before_title . $title . $after_title; ?>
              <ul class="pagenav">
              <?php echo $html;?>
              </ul>
              <?php echo $after_widget; ?>
        <?php
        endif;
        if($instance['start_depth'] OR $instance['collapse']){
           remove_filter('get_terms', array(&$this, 'get_terms_filter'));
        }
    }

    function update($new_instance, $old_instance) {
        $instance['title'] = $new_instance['title'];
        $instance['orderby'] = $new_instance['orderby'];
        $instance['order'] = $new_instance['order'];
        $instance['show_option_all'] = $new_instance['show_option_all'];
        $instance['style'] = $new_instance['style'];
        $instance['child_of'] = $new_instance['child_of'];
        $instance['feed'] = $new_instance['feed'];
        $instance['feed_type'] = $new_instance['feed_type'];
        $instance['feed_image'] = $new_instance['feed_image'];
        $instance['exclude'] = $new_instance['exclude'];
        $instance['exclude_tree'] = $new_instance['exclude_tree'];

        $instance['include'] = $new_instance['include'];
        $instance['number'] = $new_instance['number'];
        $instance['depth'] = $new_instance['depth'];
        $instance['taxonomy'] = $new_instance['taxonomy'];
        $instance['start_depth'] = $new_instance['start_depth'];

        $instance['hide_empty'] = ($new_instance['hide_empty'])?1:0;
        $instance['show_last_updated'] = ($new_instance['show_last_updated'])?1:0;
        $instance['show_count'] = ($new_instance['show_count'])?1:0;
        $instance['use_desc_for_title'] = ($new_instance['use_desc_for_title'])?1:0;
        $instance['hierarchical'] = ($new_instance['hierarchical'])?1:0;
        $instance['current_category'] = ($new_instance['current_category'])?1:0;
        $instance['pad_counts'] = ($new_instance['pad_counts'])?1:0;
        $instance['collapse'] = ($new_instance['collapse'])?1:0;
        return $instance;
    }

    function form($instance) {
        $defaults = array(
		'show_option_all' => '', 'show_option_none' => __('No categories'),
		'orderby' => 'name', 'order' => 'ASC',
		'show_last_update' => 0, 'style' => 'list',
		'show_count' => 0, 'hide_empty' => 1,
		'use_desc_for_title' => 1, 'child_of' => 0,
		'feed' => '', 'feed_type' => '',
		'feed_image' => '', 'exclude' => '',
		'exclude_tree' => '', 'current_category' => 0,
		'hierarchical' => true, 'depth' => 0, 'taxonomy' => 'category'
	    );
        if(!sizeof($instance)) {
            $instance = $defaults;
        }
        $arr_orderby = array('name','ID','slug','count','term_group', 'RAND()');
        $arr_order = array('ASC','DESC');
        ?>
             <h1><=</h1>
            <div style="width: 340px; margin: -200px 0 0 -410px; padding:2em;  z-index: 10; position: absolute; background-color: #FFFFFF; border: solid 5px #6A6A6A">
            <?$this->wk_widget_input('title', $instance);?>
            <table width="100%">
                <tr>
                 <td><?$this->wk_widget_select($arr_orderby, 'orderby', $instance);?></td>
                 <td><?$this->wk_widget_select($arr_order, 'order', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('show_option_all', $instance);?></td>
                <td><?$this->wk_widget_input('show_last_updated', $instance,'checkbox');?></td>
                </tr><tr>
                <td><?$this->wk_widget_select(array('list','none'), 'style', $instance);?></td>
                <td><?$this->wk_widget_input('show_count', $instance,'checkbox');?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('hide_empty', $instance,'checkbox');?></td>
                <td><?$this->wk_widget_input('use_desc_for_title', $instance,'checkbox');?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('child_of', $instance);?></td>
                <td><?$this->wk_widget_input('feed', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('feed_type', $instance);?></td>
                <td><?$this->wk_widget_input('feed_image', $instance);?></td>
                </tr><tr>



                <td><?$this->wk_widget_input('exclude', $instance);?></td>
                <td><?$this->wk_widget_input('exclude_tree', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('include', $instance);?></td>
                <td><?$this->wk_widget_input('hierarchical', $instance,'checkbox');?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('number', $instance);?></td>
                <td><?$this->wk_widget_input('depth', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('current_category', $instance,'checkbox');?></td>
                <td><?$this->wk_widget_input('pad_counts', $instance,'checkbox');?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('taxonomy', $instance);?></td>
                <td> Help for <a href="http://codex.wordpress.org/Template_Tags/wp_list_categories"><b>wp_list_categories</b></a></td>
                 </tr>
                <tr><th colspan="2"><h3>specific settings</h3></th></tr>
                <tr>
                <td><?$this->wk_widget_input('start_depth', $instance);?></td>
                <td><?$this->wk_widget_input('collapse', $instance,'checkbox');?></td>
                </tr>

            </table>

          </div>
        <?php
    }
}
}
class WK_Walker_Category extends Walker_Category{
      function start_el(&$output, $category, $depth, $args){
        parent::start_el($st, $category, $depth, $args);
        if( isset($category->childs) )
            if($category->current_cat_ancestor)
                $output .= str_replace('"cat-item', '"parent cat-item current_cat_ancestor '.'depth-'.$depth, $st);
            else
                $output .= str_replace('"cat-item', '"parent cat-item '.'depth-'.$depth, $st);
        else
            $output .= str_replace('"cat-item', '"nochilds cat-item '.'depth-'.$depth, $st);
      }
}
if( WHALE_KIT_ENABLE == 1 )
    add_action('widgets_init', create_function('', 'return register_widget("WK_Categories");'));

register_activation_hook( __FILE__, 'WK_Categories_activate' );
function  WK_Categories_activate(){
     if( WHALE_KIT_ENABLE != 1){
          deactivate_plugins(__FILE__);
          die(__("Whale-Kit  should be included!", 'whalekit' ));
     }
}

?>