<?php
 /*
Plugin Name: Whale-Kit Pages widget
Plugin URI: http://ili.com.ua/whale-kit/pages-widget
Description: Whale-Kit advanced pages widget
Author: Yuriy Stepanov (stur)
Version: 1.0.0
Author URI: http://ili.com.ua/
*/


if(class_exists('Whale_Kit_Widget')){
class WK_Pages  extends Whale_Kit_Widget{
    function WK_Pages(){
        parent::WP_Widget(false, $name = 'WK_Pages');
    }
    function get_pages_filter($pages, $r){
        global $wp_query;

		if ( is_page() || is_attachment() || $wp_query->is_posts_page )
			$current_id = $wp_query->get_queried_object_id();
        // construct a hierarchical tree
        foreach($pages as $key=>$value){
            $pages[$key]->key = $key;
            $ids[$value->ID] = & $pages[$key];
        }
        foreach($ids as $id=>$page){
            if($page->post_parent){
               $ids[$page->post_parent]->childs[$id] = & $ids[$id];
            }else{
               $tree[$id] = & $ids[$id];
            }
        }

        if($current_id ){

            // ancestors paht
            $current_page = get_page( $current_id );
            $ancestors = array_reverse($current_page->ancestors);
            $ancestors[] =  $current_id;
            if($r['start_depth']){
                 $start_id = $ancestors[$r['start_depth']-1];
                if(!$ids[$start_id]->childs) return '';
                $pages = $this->get_all_childs($ids[$start_id]->childs);
            }

            if($r['collapse'] and ($r['depth'] !== -1) ){
                foreach($pages as $key=>$page){
                    if($page->post_parent){
                            if(in_array($page->post_parent,$ancestors) )
                                $result[$key] = $page;
                    }
                    else
                        $result[$key] = $page;
                }
                return $result;
            }

        } else {

            if($r['start_depth']) return '';
            foreach($pages as $key=>$value){
                if(!$value->post_parent){
                    $result[$key] = $value;
                }
            }
            return $result;
        }

        return  $pages;
    }


    function widget($args, $instance) {
        extract( $args );
        $this->instance = $instance;
        $title = apply_filters('widget_title', $instance['title']);
        $instance['title_li'] = false;
        if($instance['title_lenght'])
            add_filter('the_title', array(&$this, 'sub_text'), 10, 2);
        if($instance['start_depth'] OR $instance['collapse']){
            add_filter('get_pages', array(&$this, 'get_pages_filter'), 10, 2);
            if($instance['collapse'])
                $instance['walker'] = new WK_Walker_Page;
        }
        $instance['echo'] = 0;
        $html = wp_list_pages($instance);
        if($html):
        ?>
              <?php echo $before_widget; ?>
                  <?php if ( $title )
                        echo $before_title . $title . $after_title; ?>
              <ul class="pagenav">
              <?php echo $html;?>
              </ul>
              <?php echo $after_widget; ?>
        <?php
        endif;
        if($instance['start_depth'] OR $instance['collapse']){
           remove_filter('get_pages', array(&$this, 'get_pages_filter'));

        }
        if($instance['title_lenght'])
            remove_filter('the_title', array(&$this, 'sub_text'));
    }

    function update($new_instance, $old_instance) {
        $new_instance['collapse'] = ($new_instance['collapse'])?1:0;
        return $new_instance;
    }

    function form($instance) {
        $title = esc_attr($instance['title']);
        $arr_sort_column = array('post_title','menu_order','post_modified','ID','post_author','post_name','RAND()');
        $arr_sort_order = array('ASC','DESC');
        ?>
            <h1><=</h1>
            <div style="width: 340px; margin: -200px 0 0 -410px; padding:2em;  z-index: 10; position: absolute; background-color: #FFFFFF; border: solid 5px #6A6A6A">
            <h3><?$this->wk_widget_input('title', $instance);?></h3>

            <table width="100%">
            <tr>
            <td><?$this->wk_widget_select($arr_sort_column, 'sort_column', $instance);?></td>
            <td><?$this->wk_widget_select($arr_sort_order, 'sort_order', $instance);?></td>
            </tr> <tr>
            <td><?$this->wk_widget_input('exclude', $instance);?></td>
            <td><?$this->wk_widget_input('exclude_tree', $instance);?></td>
            </tr><tr>
            <td><?$this->wk_widget_input('include', $instance);?></td>
            <td><?$this->wk_widget_input('child_of', $instance);?></td>
            </tr><tr>
            <td><?$this->wk_widget_input('show_date', $instance);?></td>
            <td><?$this->wk_widget_input('date_format', $instance);?></td>
            </tr><tr>
            <td><?$this->wk_widget_input('meta_key', $instance);?></td>
            <td><?$this->wk_widget_input('meta_value', $instance);?></td>
            </tr><tr>
            <td><?$this->wk_widget_input('link_before', $instance);?></td>
            <td><?$this->wk_widget_input('link_after', $instance);?></td>
            </tr><tr>
            <td><?$this->wk_widget_input('authors', $instance);?></td>
            <td><?$this->wk_widget_input('number', $instance);?></td>
            </tr><tr>
            <td><?$this->wk_widget_input('offset', $instance);?></td>
            <td><?$this->wk_widget_input('depth', $instance);?></td>
            </tr>
            <tr><th colspan="2">Help for <a href="http://codex.wordpress.org/Function_Reference/wp_list_pages"><b>wp_list_pages</b></a></th></tr>
            <tr><th colspan="2"><h3>specific settings</h3></th></tr>
            <tr>
            <td><?$this->wk_widget_input('start_depth', $instance);?></td>
            <td><?$this->wk_widget_input('collapse', $instance,'checkbox');?></td>
            </tr>
            <tr><td><?$this->wk_widget_input('title_lenght', $instance);?></td>
            <td><?$this->wk_widget_input('end_cut', $instance);?></td></tr>

            <!--<tr><td><?//$this->wk_widget_input('inclode_wk_css', $instance,'checkbox');?></td><td>&nbsp;</td></tr>-->
            </table>

            </div>
        <?php
    }
}
}

class WK_Walker_Page extends Walker_Page{
      function start_el(&$output, $page, $depth, $args, $current_page){
        parent::start_el($st, $page, $depth, $args, $current_page);
        if( isset($page->childs) )
           $output .= str_replace('"page_item', '"parent page_item '.'depth-'.$depth, $st);
        else
            $output .= str_replace('"page_item', '"nochilds page_item '.'depth-'.$depth, $st);
      }
}

if( WHALE_KIT_ENABLE == 1 )
    add_action('widgets_init', create_function('', 'return register_widget("WK_Pages");'));

register_activation_hook( __FILE__, 'WK_Pages_activate' );
function  WK_Pages_activate(){
     if( WHALE_KIT_ENABLE != 1){
          deactivate_plugins(__FILE__);
          die(__("Whale-Kit  should be included!", 'whalekit' ));
     }
}


?>