<?
 /*
Plugin Name: Whale-Kit Posts widget
Plugin URI: http://ili.com.ua/whale-kit/pages-widget
Description: Whale-Kit advanced Recent Posts widget
Author: Yuriy Stepanov (stur)
Version: 1.0.0
Author URI: http://ili.com.ua/
*/

if(class_exists('Whale_Kit_Widget')){
class WK_Posts  extends Whale_Kit_Widget{
    function WK_Posts(){
        parent::WP_Widget(false, $name = 'WK_Posts');
    }
    function posts_fields_request($fields){
        return $fields.", image.ID  AS image";
    }
    function posts_join_request($join){
        global $wpdb;
        return $join." INNER JOIN $wpdb->posts image ON ($wpdb->posts.ID = image.post_parent) ";
    }
    function posts_where_request($where){
        return $where." AND image.menu_order = 0 AND image.post_mime_type like 'image%' ";
    }
    function widget($args, $instance) {
        extract( $args );
        $title = apply_filters('widget_title', $instance['title']);
        $instance = $this->prepea_instance($instance);
        $this->instance = $instance;
        $instance['no_found_rows'] = 1;
        if($instance['image_size']){
             add_filter('posts_fields_request', array(&$this, 'posts_fields_request'));
             add_filter('posts_join_request', array(&$this, 'posts_join_request'));
             add_filter('posts_where_request', array(&$this, 'posts_where_request'));
        }
        $r = new WP_Query($instance);

        if ($r->have_posts()) :
        if($instance['image_size']){
            list($width,$height) = explode('x',$instance['image_size']);
        }
?>
		<?php echo $before_widget; ?>
		<?php if ( $title ) echo $before_title . $title . $after_title; ?>
		<ul>
		<?php  while ($r->have_posts()) :
            $r->the_post();
            $atr_title = $title = get_the_title();
            $title = $title ? $title : get_the_ID();
            if($instance['title_lenght']) $title = $this->sub_text($title);
            elseif ($instance['title_lenght'] === '0') $title = '';
            if($width){
                $img =  "<img src='".wp_get_attachment_thumb_url($r->post->image)."' width='{$width}px' height='{$height}px' />";
            }
        ?>
		<li><a class="wk_posts_img" href="<?php the_permalink() ?>" title="<?php echo esc_attr($atr_title); ?>"><?=$img?><?=$title?></a></li>
		<?php endwhile; ?>
		</ul>
		<?php echo $after_widget; ?>
<?php
		// Reset the global $the_post as this query will have stomped on it
		wp_reset_postdata();
        if($instance['image_size']){
             remove_filter('posts_fields_request', array(&$this, 'posts_fields_request'));
             remove_filter('posts_join_request', array(&$this, 'posts_join_request'));
             remove_filter('posts_where_request', array(&$this, 'posts_where_request'));
        }
		endif;

    }
    function prepea_instance($arr){

        $arr['category__and'] = $this->convert_to_array( $arr['category__and'] );
        $arr['category__in'] = $this->convert_to_array( $arr['category__in'] );
        $arr['category__not_in'] = $this->convert_to_array( $arr['category__not_in'] );

        $arr['tag__and'] = $this->convert_to_array( $arr['tag__and'] );
        $arr['tag__in'] = $this->convert_to_array( $arr['tag__in'] );
        $arr['tag__not_in'] = $this->convert_to_array( $arr['tag__not_in'] );
        $arr['tag_slug__and'] = $this->convert_to_array( $arr['tag_slug__and'] );
        $arr['tag_slug__in'] = $this->convert_to_array( $arr['tag_slug__in'] );

        $arr['post__in'] = $this->convert_to_array( $arr['post__in'] );
        $arr['post__not_in'] = $this->convert_to_array( $arr['post__not_in'] );
        $arr['post_type'] = $this->convert_to_array( $arr['post_type'] );
        if ($arr['hour'] OR  $arr['minute'] OR  $arr['second'] OR  $arr['day'] OR  $arr['monthnum'] OR  $arr['year'] OR $arr['w']){
            $now = getdate();
            if($arr['hour'] == 'now')$arr['hour'] = $now['hours'];
            if($arr['minute'] == 'now')$arr['minute'] = $now['minutes'];
            if($arr['second'] == 'now')$arr['second'] = $now['seconds'];
            if($arr['day'] == 'now')$arr['day'] = $now['mday'];
            if($arr['monthnum'] == 'now')$arr['monthnum'] = $now['mon'];
            if($arr['year'] == 'now')$arr['year'] = $now['year'];
            if($arr['w'] == 'now'){
                $week = date('W');
                $arr['w'] = $week;
            }
        }


        return $arr;

    }
    function convert_to_array($st){
        if(empty($st)) return '';
        return preg_split('/\s?,\s?/', $st,-1,PREG_SPLIT_NO_EMPTY);
    }
    function update($new_instance, $old_instance) {
        return $new_instance;
    }

    function form($instance) {
        $title = esc_attr($instance['title']);
        $arr_orderby = array('date','author','title','modified','menu_order','parent','ID','rand','meta_value','meta_value_num','none','comment_count');
        $arr_order = array('DESC','ASC');
        $this->convert_to_array($instance['category__and']);
        ?>
        <h1><=</h1>
            <div style="width: 440px; margin: -200px 0 0 -510px; padding:2em;  z-index: 10; position: absolute; background-color: #FFFFFF; border: solid 5px #6A6A6A">
                <?$this->wk_widget_input('title', $instance);?>
                <table width="100%">
                <tr><th colspan="3">Category Parameters</th></tr>
                <tr>
                <td><?$this->wk_widget_input('cat', $instance);?></td>
                <td><?$this->wk_widget_input('category_name', $instance);?></td>
                <td><?$this->wk_widget_input('category__and', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('category__in', $instance);?></td>
                <td><?$this->wk_widget_input('category__not_in', $instance);?></td>
                <td>&nbsp;</td>
                </tr>
                <tr><th colspan="3">Tag Parameters</th></tr>
                <tr>
                <td><?$this->wk_widget_input('tag', $instance);?></td>
                <td><?$this->wk_widget_input('tag_id', $instance);?></td>
                <td><?$this->wk_widget_input('tag__and', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('tag__in', $instance);?></td>
                <td><?$this->wk_widget_input('tag__not_in', $instance);?></td>
                <td><?$this->wk_widget_input('tag_slug__and', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('tag_slug__in', $instance);?></td>
                <td>&nbsp;</td>
                <td>&nbsp;</td>
                </tr>
                <tr><th colspan="3">Author Parameters</th></tr>
                <tr>
                <td><?$this->wk_widget_input('author', $instance);?></td>
                <td><?$this->wk_widget_input('author_name', $instance);?></td>
                <td>&nbsp;</td>

                <tr><th colspan="3">Post & Page Parameters</th></tr>
                <tr>
                <td><?$this->wk_widget_input('p', $instance);?></td>
                <td><?$this->wk_widget_input('name', $instance);?></td>
                <td><?$this->wk_widget_input('page_id', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('pagename', $instance);?></td>
                <td><?$this->wk_widget_input('post_type', $instance);?></td>
                <td><?$this->wk_widget_input('post_parent', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('post__in', $instance);?></td>
                <td><?$this->wk_widget_input('post__not_in', $instance);?></td>
                <td><?$this->wk_widget_input('post_status', $instance);?></td>
                </tr>

                <!--<tr><th colspan="3">Sticky Post Parameters</th></tr>
                <tr>
                <td><?$this->wk_widget_input('all_sticky', $instance);?></td>
                <td><?$this->wk_widget_input('caller_get_posts', $instance);?></td>
                <td>&nbsp;</td>
                </tr>-->

                <tr><th colspan="3">Time Parameters</th></tr>
                <tr>
                <td><?$this->wk_widget_input('minute', $instance);?></td>
                <td><?$this->wk_widget_input('hour', $instance);?></td>
                <td><?$this->wk_widget_input('day', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('monthnum', $instance);?></td>
                <td><?$this->wk_widget_input('w', $instance);?></td>
                <td><?$this->wk_widget_input('year', $instance);?></td>
                </tr>
                <tr><td colspan="3">to substitute the current date, use the key <b>now</b></td></tr>
                <tr><th colspan="3">Pagination & Offset Parameters</th></tr>
                <tr>
                <td><?$this->wk_widget_input('nopaging', $instance);?></td>
                <td><?$this->wk_widget_input('posts_per_page', $instance);?></td>
                <td><?$this->wk_widget_input('showposts', $instance);?></td>
                </tr><tr>
                <td><?$this->wk_widget_input('paged', $instance);?></td>
                <td><?$this->wk_widget_input('offset', $instance);?></td>
                <td>&nbsp;</td>
                </tr>
                <tr><th colspan="3">Orderby & Order Parameters</th></tr>
                <tr>
                <td><?$this->wk_widget_select($arr_orderby, 'orderby', $instance);?></td>
                 <td><?$this->wk_widget_select($arr_order, 'order', $instance);?></td>
                 <td>&nbsp;</td>
                </tr>
                <tr><th colspan="3">Custom Field Parameters</th></tr>
                <td><?$this->wk_widget_input('meta_key', $instance);?></td>
                <td><?$this->wk_widget_input('meta_value', $instance);?></td>
                <td><?$this->wk_widget_input('meta_compare', $instance);?></td>
                <tr><td colspan="32">Help for <a href="http://codex.wordpress.org/Template_Tags/query_posts"><b>query_posts</b></a></td></tr>

                <tr><th colspan="3">Specific settings</th></tr>
                <tr>
                <td><?$this->wk_widget_input('title_lenght', $instance);?></td>
                <td><?$this->wk_widget_input('end_cut', $instance);?></td>
                <td><?$this->wk_widget_input('image_size', $instance);?></td>
                </tr>
                </table>
            </div>
        <?
    }
}
}

if( WHALE_KIT_ENABLE == 1 )
    add_action('widgets_init', create_function('', 'return register_widget("WK_Posts");'));

register_activation_hook( __FILE__, 'WK_Posts_activate' );
function  WK_Posts_activate(){
     if( WHALE_KIT_ENABLE != 1){
          deactivate_plugins(__FILE__);
          die(__("Whale-Kit  should be included!", 'whalekit' ));
     }
}
